; ---------------------------------------------------------------------------
; Object 38 - shield and invincibility stars
; ---------------------------------------------------------------------------

ShieldItem:				; XREF: Obj_Index
		moveq	#0,d0
		move.b	obRoutine(a0),d0
		move.w	Shi_Index(pc,d0.w),d1
		jmp	Shi_Index(pc,d1.w)
; ===========================================================================
Shi_Index:	dc.w Shi_Main-Shi_Index
		dc.w Shi_Shield-Shi_Index
		dc.w Shi_Stars-Shi_Index
; ===========================================================================

Shi_Main:	; Routine 0
		addq.b	#2,obRoutine(a0)
		move.l	#Map_Shield,obMap(a0)
		move.b	#4,obRender(a0)
		move.b	#1,obPriority(a0)
		move.b	#$10,obActWid(a0)
		tst.b	obAnim(a0)	; is object a shield?
		bne.s	@stars		; if not, branch
		move.w	#$541,obGfx(a0)	; shield specific code
		rts	
; ===========================================================================

@stars:
		addq.b	#2,obRoutine(a0) ; goto Shi_Stars next
		move.w	#$55C,obGfx(a0)
		rts	
; ===========================================================================

Shi_Shield:	; Routine 2
		tst.b	(v_invinc).w	; does Sonic have invincibility?
		bne.s	@remove		; if yes, branch
		tst.b	(v_shield).w	; does Sonic have shield?
		beq.s	@delete		; if not, branch
		move.w	(v_player+obX).w,obX(a0)
		move.w	(v_player+obY).w,obY(a0)
		move.b	(v_player+obStatus).w,obStatus(a0)
	
	;Mercury Shield/Invincibility Positioning Fix
		move.b	obStatus(a0),d0
		move.w	#$A,d1
		
	if BalanceCDActive=1	;Mercury Balance CD
		cmpi.b	#id_BalanceForward,(v_player+obAnim).w
		beq.s	@shift
		cmpi.b	#id_BalanceBack,(v_player+obAnim).w
		bne.s	@noshift
		bchg	#staFacing,d0	;Mercury Constants
		move.w	#4,d1
	else
		cmpi.b	#id_Balance,(v_player+obAnim).w
		bne.s	@noshift
	endc	;end Balance CD
		
	@shift:
		sub.w	d1,obX(a0)
		btst	#staFacing,d0	;Mercury Constants
		beq.s	@noshift
		add.w	d1,d1
		add.w	d1,obX(a0)
	@noshift:
	;end Shield/Invincibility Positioning Fix
		
		lea	(Ani_Shield).l,a1
		jsr	AnimateSprite
		jmp	DisplaySprite

	@remove:
		rts	

	@delete:
		jmp	DeleteObject
; ===========================================================================

Shi_Stars:	; Routine 4
		tst.b	(v_invinc).w	; does Sonic have invincibility?
		beq.w	@delete		; if not, branch	;Mercury Shield/Invincibility Positioning Fix (beq.s -> beq.w)
		move.w	(v_trackpos).w,d0 ; get index value for tracking data
		move.b	obAnim(a0),d1
		subq.b	#1,d1
		bra.s	@trail
; ===========================================================================
		lsl.b	#4,d1
		addq.b	#4,d1
		sub.b	d1,d0
		move.b	$30(a0),d1
		sub.b	d1,d0
		addq.b	#4,d1
		andi.b	#$F,d1
		move.b	d1,$30(a0)
		bra.s	@b
; ===========================================================================

@trail:
		lsl.b	#3,d1		; multiply animation number by 8
		move.b	d1,d2
		add.b	d1,d1
		add.b	d2,d1		; multiply by 3
		addq.b	#4,d1
		sub.b	d1,d0
		move.b	$30(a0),d1
		sub.b	d1,d0		; use earlier tracking data to create trail
		addq.b	#4,d1
		cmpi.b	#$18,d1
		bcs.s	@a
		moveq	#0,d1

	@a:
		move.b	d1,$30(a0)

	@b:
		lea	(v_tracksonic).w,a1
		lea	(a1,d0.w),a1
		move.w	(a1)+,obX(a0)
		move.w	(a1)+,obY(a0)
		move.b	(v_player+obStatus).w,obStatus(a0)
		
	;Mercury Shield/Invincibility Positioning Fix
		move.b	obStatus(a0),d0
		move.w	#$A,d1
		
	if BalanceCDActive=1	;Mercury Balance CD
		cmpi.b	#id_BalanceForward,(v_player+obAnim).w
		beq.s	@shift
		cmpi.b	#id_BalanceBack,(v_player+obAnim).w
		bne.s	@noshift
		bchg	#staFacing,d0	;Mercury Constants
		move.w	#4,d1
	else
		cmpi.b	#id_Balance,(v_player+obAnim).w
		bne.s	@noshift
	endc	;end Balance CD
		
	@shift:
		sub.w	d1,obX(a0)
		btst	#staFacing,d0	;Mercury Constants
		beq.s	@noshift
		add.w	d1,d1
		add.w	d1,obX(a0)
	@noshift:
	;end Shield/Invincibility Positioning Fix
		
		lea	(Ani_Shield).l,a1
		jsr	AnimateSprite
		jmp	DisplaySprite
; ===========================================================================

@delete:
		jmp	DeleteObject
